## install4j API documentation

## com.install4j.api.beaninfo
Class ActionBeanInfo

    java.lang.Object
      java.beans.SimpleBeanInfo
          com.install4j.api.beaninfo.Install4JBeanInfo
              com.install4j.api.beaninfo.ActionBeanInfo

All Implemented Interfaces:
  java.beans.BeanInfo

    public abstract class ActionBeanInfo

extends Install4JBeanInfo

Base class for bean infos of actions classes.

Using this class is not strictly required. In principle, you could also set values for the `ATTRIBUTE_*` constants in the bean descriptor of an unrelated bean info class.

Field Summary
`static java.lang.String` | `ATTRIBUTE_ASSOCIATED_CONFIRMATION`
`static java.lang.String` | `ATTRIBUTE_ASSOCIATED_CONFIRMATION_INIT_SCRIPT`
`static java.lang.String` | `ATTRIBUTE_ASSOCIATED_CONFIRMATION_VISIBILITY_SCRIPT`
`static java.lang.String` | `ATTRIBUTE_ASSOCIATED_SCREEN`
`static java.lang.String` | `ATTRIBUTE_ASSOCIATED_STARTUP_ACTION`
`static java.lang.String` | `ATTRIBUTE_ASSOCIATED_STARTUP_ACTION_INSTALLER_AND_UNINSTALLER`
`static java.lang.String` | `ATTRIBUTE_DEFAULT_ERROR_MESSAGE`
`static java.lang.String` | `ATTRIBUTE_DEFAULT_FAILURE_STRATEGY`
`static java.lang.String` | `ATTRIBUTE_INSTALLER_TARGET_SCREEN`
`static java.lang.String` | `ATTRIBUTE_UNINSTALLER_TARGET_SCREEN`

Fields inherited from class com.install4j.api.beaninfo.Install4JBeanInfo
`ATTRIBUTE_BEAN_CATEGORY, ATTRIBUTE_BEAN_INITIALIZER, ATTRIBUTE_BEAN_VALIDATOR, ATTRIBUTE_COLLAPSED_PROPERTY_CATEGORIES, ATTRIBUTE_CUSTOMIZER_ICON, ATTRIBUTE_CUSTOMIZER_PLACEMENT, ATTRIBUTE_DEFAULT_CONDITION_EXPRESSION, ATTRIBUTE_DEFAULT_ROLLBACK_BARRIER, ATTRIBUTE_ENUMERATION_MAPPERS, ATTRIBUTE_ICON_16x16, ATTRIBUTE_ICON_24x24, ATTRIBUTE_INSTALLED_FILES_REQUIRED, ATTRIBUTE_MINIMUM_JAVA_VERSION, ATTRIBUTE_MULTIPLE_INSTANCES_SUPPORTED, ATTRIBUTE_NOTICE_PANEL, ATTRIBUTE_PERSISTENCE_DELEGATE_MAP, ATTRIBUTE_PROPERTY_CONVERTERS, ATTRIBUTE_SEQUENCE_VALIDATOR, ATTRIBUTE_SORT_KEY`

Fields inherited from interface java.beans.BeanInfo
`ICON_COLOR_16x16, ICON_COLOR_32x32, ICON_MONO_16x16, ICON_MONO_32x32`

Constructor Summary
`protected` | `ActionBeanInfo(java.lang.String displayName, java.lang.String shortDescription, java.lang.String category, boolean multipleInstancesSupported, boolean installedFilesRequired, java.lang.Integer sortKey, java.lang.Class beanClass)` Same as `ActionBeanInfo(String, String, String, boolean, boolean, Integer, Class, Class)` with a customizer class of `null`.
`protected` | `ActionBeanInfo(java.lang.String displayName, java.lang.String shortDescription, java.lang.String category, boolean multipleInstancesSupported, boolean installedFilesRequired, java.lang.Integer sortKey, java.lang.Class beanClass, java.lang.Class customizerClass)` Same as `Install4JBeanInfo.Install4JBeanInfo(String, String, String, boolean, boolean, Integer, Class, Class)`

Method Summary
`void` | `setAssociatedConfirmation(java.lang.String confirmationDescription, java.lang.String initScript)` Deprecated.
`void` | `setAssociatedConfirmation(java.lang.String confirmationDescription, java.lang.String initScript, java.lang.String visibilityScript)` Configures an associated confirmation.
`void` | `setAssociatedScreen(java.lang.String className)` Configures an associated screen.
`void` | `setAssociatedStartupAction(java.lang.String className, boolean installerAndUninstaller)` Configures an associated startup action.
`void` | `setDefaultErrorMessage(java.lang.String errorMessage)` Configures the default error message for the action.
`void` | `setDefaultFailureStrategy(FailureStrategy failureStrategy)` Configures the default failure strategy for the action.
`void` | `setInstallerTargetScreen(java.lang.String className)` Configures a target screen for the installer.
`void` | `setUninstallerTargetScreen(java.lang.String className)` Configures a target screen for the uninstaller.

Methods inherited from class com.install4j.api.beaninfo.Install4JBeanInfo
`addPropertyDescriptor, checkNotEmpty, checkNotEmpty, findPropertyDescriptor, getBeanClass, getBeanDescriptor, getPropertyDescriptors, getPropertyValue, getPropertyValue, isEmpty, setBeanInitializer, setBeanValidator, setCollapsedPropertyCategories, setCustomizerIcon, setCustomizerPlacement, setDefaultConditionExpression, setDefaultRollbackBarrier, setEnumerationMappers, setIcons, setMinimumJavaVersion, setNoticePanel, setPersistenceDelegateMap, setPropertyConverters, setSequenceValidator`

Methods inherited from class java.beans.SimpleBeanInfo
`getAdditionalBeanInfo, getDefaultEventIndex, getDefaultPropertyIndex, getEventSetDescriptors, getIcon, getMethodDescriptors, loadImage`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ATTRIBUTE_ASSOCIATED_CONFIRMATION

    public static final java.lang.String ATTRIBUTE_ASSOCIATED_CONFIRMATION

See Also:
  `setAssociatedConfirmation(String, String, String)`, Constant Field Values

### ATTRIBUTE_ASSOCIATED_CONFIRMATION_INIT_SCRIPT

    public static final java.lang.String ATTRIBUTE_ASSOCIATED_CONFIRMATION_INIT_SCRIPT

See Also:
  `setAssociatedConfirmation(String, String, String)`, Constant Field Values

### ATTRIBUTE_ASSOCIATED_CONFIRMATION_VISIBILITY_SCRIPT

    public static final java.lang.String ATTRIBUTE_ASSOCIATED_CONFIRMATION_VISIBILITY_SCRIPT

See Also:
  `setAssociatedConfirmation(String, String, String)`, Constant Field Values

### ATTRIBUTE_ASSOCIATED_SCREEN

    public static final java.lang.String ATTRIBUTE_ASSOCIATED_SCREEN

See Also:
  `setAssociatedScreen(String)`, Constant Field Values

### ATTRIBUTE_INSTALLER_TARGET_SCREEN

    public static final java.lang.String ATTRIBUTE_INSTALLER_TARGET_SCREEN

See Also:
  `setInstallerTargetScreen(String)`, Constant Field Values

### ATTRIBUTE_UNINSTALLER_TARGET_SCREEN

    public static final java.lang.String ATTRIBUTE_UNINSTALLER_TARGET_SCREEN

See Also:
  `setUninstallerTargetScreen(String)`, Constant Field Values

### ATTRIBUTE_ASSOCIATED_STARTUP_ACTION

    public static final java.lang.String ATTRIBUTE_ASSOCIATED_STARTUP_ACTION

See Also:
  `setAssociatedStartupAction(String, boolean)`, Constant Field Values

### ATTRIBUTE_ASSOCIATED_STARTUP_ACTION_INSTALLER_AND_UNINSTALLER

    public static final java.lang.String ATTRIBUTE_ASSOCIATED_STARTUP_ACTION_INSTALLER_AND_UNINSTALLER

See Also:
  `ATTRIBUTE_ASSOCIATED_STARTUP_ACTION_INSTALLER_AND_UNINSTALLER`, Constant Field Values

### ATTRIBUTE_DEFAULT_FAILURE_STRATEGY

    public static final java.lang.String ATTRIBUTE_DEFAULT_FAILURE_STRATEGY

See Also:
  `ATTRIBUTE_DEFAULT_FAILURE_STRATEGY`, Constant Field Values

### ATTRIBUTE_DEFAULT_ERROR_MESSAGE

    public static final java.lang.String ATTRIBUTE_DEFAULT_ERROR_MESSAGE

See Also:
  `ATTRIBUTE_DEFAULT_ERROR_MESSAGE`, Constant Field Values

Constructor Detail

### ActionBeanInfo

    protected ActionBeanInfo(java.lang.String displayName,
                             java.lang.String shortDescription,
                             java.lang.String category,
                             boolean multipleInstancesSupported,
                             boolean installedFilesRequired,
                             java.lang.Integer sortKey,
                             java.lang.Class beanClass,
                             java.lang.Class customizerClass)

  Same as `Install4JBeanInfo.Install4JBeanInfo(String, String, String, boolean, boolean, Integer, Class, Class)`

### ActionBeanInfo

    protected ActionBeanInfo(java.lang.String displayName,
                             java.lang.String shortDescription,
                             java.lang.String category,
                             boolean multipleInstancesSupported,
                             boolean installedFilesRequired,
                             java.lang.Integer sortKey,
                             java.lang.Class beanClass)

  Same as `ActionBeanInfo(String, String, String, boolean, boolean, Integer, Class, Class)` with a customizer class of `null`.

Method Detail

### setAssociatedConfirmation

    public void setAssociatedConfirmation(java.lang.String confirmationDescription,
                                          java.lang.String initScript)

  Deprecated.

  Kept for backwards compatibility

  See Also:
    `setAssociatedConfirmation(String, String, String)`

### setAssociatedConfirmation

    public void setAssociatedConfirmation(java.lang.String confirmationDescription,
                                          java.lang.String initScript,
                                          java.lang.String visibilityScript)

  Configures an associated confirmation. If the user adds the action, the install4j GUI will ask the user whether to add a question to the associated screen, if the screen is a form screen or to the "Additional confirmation" screen otherwise. The form screen will receive a check box form component with a variable name equal to the simple class name of the action. The condition expression of the action will be set to `context.getBooleanVariable("variableName")` so that the confirmation and the execution of the action are automatically wired together.

  If the `initScript` parameter is not `null` and the user accepts the addition of the confirmation, the "Initialization script" property of the check box form component is set to `initScript`.

  Parameters:
    `confirmationDescription` - the message of the confirmation
    `initScript` - the init script, may be `null` @see #ATTRIBUTE_ASSOCIATED_CONFIRMATION
    `visibilityScript` - the visibility script, may be `null` @see #ATTRIBUTE_ASSOCIATED_CONFIRMATION
  See Also:
    `ATTRIBUTE_ASSOCIATED_CONFIRMATION_INIT_SCRIPT`

### setAssociatedScreen

    public void setAssociatedScreen(java.lang.String className)

  Configures an associated screen. If set, and the user adds the action, the install4j GUI checks if an instance of the specified class is present in the list of configured screens. If not, it will ask the user whether to add such a screen.

  Parameters:
    `className` - the class name of the associated screen
  See Also:
    `ATTRIBUTE_ASSOCIATED_SCREEN`

### setInstallerTargetScreen

    public void setInstallerTargetScreen(java.lang.String className)

  Configures a target screen for the installer. If set, and the user adds the action, the install4j GUI checks if the current screen is an instance of the specified class. If not, it will ask the user whether the action should rather be added to the target screen, adding that screen if it is not present in the list of configured screens.

  Parameters:
    `className` - the class name of the target screen
  See Also:
    `ATTRIBUTE_INSTALLER_TARGET_SCREEN`

### setUninstallerTargetScreen

    public void setUninstallerTargetScreen(java.lang.String className)

  Configures a target screen for the uninstaller. If set, and the user adds the action, the install4j GUI checks if the current screen is an instance of the specified class. If not, it will ask the user whether the action should rather be added to the target screen, adding that screen if it is not present in the list of configured screens.

  Parameters:
    `className` - the class name of the target screen
  See Also:
    `ATTRIBUTE_UNINSTALLER_TARGET_SCREEN`

### setAssociatedStartupAction

    public void setAssociatedStartupAction(java.lang.String className,
                                           boolean installerAndUninstaller)

  Configures an associated startup action. If set, and the user adds the action, the install4j GUI checks if the startup screen contains an action of the specified class. If not, it will ask the user whether the action of that class should be added to the startup screen.

  Parameters:
    `className` - the class name of the associated startup action
    `installerAndUninstaller` - if the startup action should be added for both the installer and uninstaller or for the installer only
  See Also:
    `ATTRIBUTE_ASSOCIATED_STARTUP_ACTION`, `ATTRIBUTE_ASSOCIATED_STARTUP_ACTION_INSTALLER_AND_UNINSTALLER`

### setDefaultFailureStrategy

    public void setDefaultFailureStrategy(FailureStrategy failureStrategy)

  Configures the default failure strategy for the action.

  Parameters:
    `failureStrategy` - the default failure strategy
  See Also:
    `ATTRIBUTE_DEFAULT_FAILURE_STRATEGY`

### setDefaultErrorMessage

    public void setDefaultErrorMessage(java.lang.String errorMessage)

  Configures the default error message for the action.

  Parameters:
    `errorMessage` - the default error message
  See Also:
    `ATTRIBUTE_DEFAULT_ERROR_MESSAGE`